/*****************************************************
This program was produced by the
CodeWizardAVR V2.04.2b Evaluation
Automatic Program Generator
 Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 25.10.2009
Author  : Freeware, for evaluation and non-commercial use only
Company : 
Comments: 


Chip type               : ATmega8
Program type            : Application
AVR Core Clock frequency: 8,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256
*****************************************************/

#include <mega8.h>

#include <delay.h>                                 



unsigned char msec=0;
unsigned char sec=0;
unsigned char min=0;
unsigned char hour=0; //    1    2    3    4    5    6    7    8    9    10  11   12   13   14
unsigned char C[15]={0xff,0xff,0xff,0xff,0xff,0xdf,0xaf,0xf7,0xfb,0xfd,0xff,0xff,0x00,0x01,0xed} ;
unsigned char D[15]={0xef,0xf7,0xfb,0xfd,0xfe,0xff,0xff,0xff,0xff,0xff,0xbf,0xdf,0x00,0x00,0xed} ;
char i;
eeprom char mode=0; // . 1 , 2 ,   1 , ..    
eeprom char DelayTime=10;
// Declare your global variables here

// Timer1 output compare A interrupt service routine
interrupt [TIM1_COMPA] void timer1_compa_isr(void)
{
TCNT1=0x0000;
  
// Place your code here
msec++;//PORTB.3=~PORTB.3;
if (msec>99) 
    { 
        msec=0;
        sec++;
        if (sec>59)
            {
                sec=0;
                min++;
                if (min>59)
                    {
                        min=0;
                        hour++; 
                        if (hour>11)
                            {
                                hour=0;
                            }
                    }
            }
    }
    

}



void SetLed(char LedN, char ColorLed)
{    
      if(ColorLed==1)
     {PORTC=C[LedN];PORTD=D[LedN];  } 
    if(ColorLed==2)
     {PORTC=~C[LedN];PORTD=~D[LedN];  }     
    
}

interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
//i=0;
if(i==0)SetLed((min/5)%12,1);
if(i==1)SetLed((hour)%12,2);
if(i==2)SetLed((hour)%12,2);
//if(i==1)SetLed(13,1);
//if(i==2)SetLed(14,1);
//if(i==3)SetLed((hour)%12,2);
i++;if(i>2)i=0;
}

void main(void)
{
PORTB=0xff;
DDRB=0x00;DDRB.3=1;
PORTC=0x40;
DDRC=0x7F;
PORTD=0x00;
DDRD=0xFF;
TCCR0=0x03;
TCNT0=0x00;
TCCR1A=0x00;

TCCR1B=0x03;//TCCR1B=0x04;

TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;

OCR1AH=0x04;//OCR1AH=0x01;
OCR1AL=0xe2;//OCR1AL=0x38;

OCR1BH=0x00;
OCR1BL=0x00;
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;
MCUCR=0x00;
TIMSK=0x11;
ACSR=0x80;
SFIOR=0x00;
#asm("sei")

while (1)
      { 
     while(PINB.1==0){delay_ms(200);if(msec>10){min++;msec=0;};}  ;
     while(PINB.2==0){delay_ms(200);if(sec>0){hour++;sec=0;};}  ;
      };
}
